/*
 * RC6-32/20/8 implementation, beta
 *   by Berke Durak <berke@gsu.linux.org.tr>
 *
 */

#ifdef RC6_ENABLED
#ifndef RC6_H
#define RC6_H
#include <stdio.h>

#ifndef U32U16U8
typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;
#define U32U16U8
#endif

#define RC6_LGW 5
#define RC6_W (1<<RC6_LGW)
#define RC6_WMSK (RC6_W-1)
#ifdef WEAK_RC6
#define RC6_R 4
#else
#define RC6_R 20
#endif
#define RC6_B 16
#define RC6_C ((RC6_B*8)>>RC6_LGW)
#define RC6_PW 0xb7e15163
#define RC6_QW 0x9e3779b9

struct rc6_KeySchedule {
	u32 s[2*RC6_R+4];
};

void rc6_SetupKey (u8 k[RC6_B], struct rc6_KeySchedule *ks);
void rc6_Encrypt (u32 src[4], u32 dst[4], struct rc6_KeySchedule *ks);
void rc6_Decrypt (u32 src[4], u32 dst[4], struct rc6_KeySchedule *ks);
#endif
#endif /* RC6_ENABLED */
